#include "stdafx.h"
#include "PluginTimer.h"

extern TPWPFunctions g_pwpfunc_t;

using namespace PWSPlugin;

PluginTimer::PluginTimer(TPWPTimerHandle h, Proc^ tp)
{
	this->handle = h;
	this->timerProc = tp;
}

void PluginTimer::Call(SystemFunctions^ sf)
{
	this->timerProc(sf);
}

int PluginTimer::Destroy()
{
	return g_pwpfunc_t.PWPTimer_Destroy(this->handle);
}

int PluginTimer::Start()
{
	return g_pwpfunc_t.PWPTimer_Start(this->handle);
}

int PluginTimer::Stop()
{
	return g_pwpfunc_t.PWPTimer_Stop(this->handle);
}

int PluginTimer::ResetInterval(int interval)
{
	return g_pwpfunc_t.PWPTimer_ResetInterval(this->handle, interval);
}
